package com.cirmuller.maidaddition.Utils.CraftingTasks;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.cirmuller.maidaddition.Utils.CraftingTasks.AbstractCraftingTask;
import com.cirmuller.maidaddition.Utils.CraftingTasks.ItemList;
import java.util.ArrayList;
import java.util.List;
import java.util.Stack;
import javax.annotation.Nullable;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.CraftingRecipe;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.level.ItemLike;

public class CraftingTask extends AbstractCraftingTask {
  ItemStack itemToTakeOut;
  
  CraftingRecipe currentRecipe;
  
  CraftingState state;
  
  public boolean isTargetItem;
  
  public CraftingRecipe getCurrentRecipe() {
    return this.currentRecipe;
  }
  
  public CraftingTask(ServerLevel level, AbstractCraftingTask parentAbstractCraftingTask, CraftingRecipe parentCraftingRecipe, @Nullable Ingredient ingredientToCraft, @Nullable Integer count) {
    super(level, parentAbstractCraftingTask, parentCraftingRecipe, ingredientToCraft, count);
    this.state = CraftingState.IDLE;
    this.currentRecipe = null;
    this.itemToTakeOut = null;
    this.isTargetItem = false;
  }
  
  public CraftingTask(AbstractCraftingTask abstractCraftingTask) {
    super(abstractCraftingTask);
    this.itemToTakeOut = null;
    this.currentRecipe = null;
    this.state = CraftingState.IDLE;
  }
  
  public ItemStack getItemToTakeOut() {
    return this.itemToTakeOut;
  }
  
  public CraftingState getState() {
    return this.state;
  }
  
  @Nullable
  public Stack<com.cirmuller.maidaddition.Utils.CraftingTasks.CraftingTask> createCraftingTasksStack(ItemList list) {
    ItemStack itemInList = null;
    for (ItemStack itemStack : list) {
      if (this.resultIngredient.test(itemStack)) {
        itemInList = itemStack;
        break;
      } 
    } 
    if (itemInList != null) {
      Stack<com.cirmuller.maidaddition.Utils.CraftingTasks.CraftingTask> result = new Stack<>();
      if (this.count <= itemInList.m_41613_()) {
        this.itemToTakeOut = new ItemStack((ItemLike)itemInList.m_41720_(), this.count);
        this.state = CraftingState.TAKING_MATERIAL;
        result.push(this);
        return result;
      } 
      this.itemToTakeOut = itemInList.m_41777_();
      ItemList listNext = list.copy();
      ItemStack toErase = listNext.getItemInList(itemInList);
      listNext.remove(toErase);
      this.state = CraftingState.TAKING_MATERIAL;
      result.push(this);
      com.cirmuller.maidaddition.Utils.CraftingTasks.CraftingTask craftingTaskNext = new com.cirmuller.maidaddition.Utils.CraftingTasks.CraftingTask(this.level, this, this.preRecipe, this.resultIngredient, Integer.valueOf(this.count - itemInList.m_41613_()));
      Stack<com.cirmuller.maidaddition.Utils.CraftingTasks.CraftingTask> task = craftingTaskNext.createCraftingTasksStack(listNext);
      result.addAll(task);
      return result;
    } 
    List<Stack<com.cirmuller.maidaddition.Utils.CraftingTasks.CraftingTask>> results = new ArrayList<>(this.allPossibleRoutes.size());
    for (CraftingRecipe recipe : this.allPossibleRoutes) {
      List<com.cirmuller.maidaddition.Utils.CraftingTasks.CraftingTask> tasks = createCraftingTasksList(recipe);
      if (tasks == null)
        return null; 
      Stack<com.cirmuller.maidaddition.Utils.CraftingTasks.CraftingTask> currentCraftingStackStack = new Stack<>();
      boolean isResultNull = false;
      for (com.cirmuller.maidaddition.Utils.CraftingTasks.CraftingTask task : tasks) {
        Stack<com.cirmuller.maidaddition.Utils.CraftingTasks.CraftingTask> stackOfCraftingTasks = task.createCraftingTasksStack(list.copy());
        if (stackOfCraftingTasks == null) {
          isResultNull = true;
          break;
        } 
        currentCraftingStackStack.addAll(stackOfCraftingTasks);
      } 
      if (isResultNull) {
        results.add(null);
        continue;
      } 
      results.add(currentCraftingStackStack);
    } 
    Stack<com.cirmuller.maidaddition.Utils.CraftingTasks.CraftingTask> minResult = null;
    for (Stack<com.cirmuller.maidaddition.Utils.CraftingTasks.CraftingTask> stack : results) {
      if (stack == null)
        continue; 
      if (minResult == null || minResult.size() > stack.size())
        minResult = stack; 
    } 
    if (minResult != null) {
      this.state = CraftingState.Crafting;
      int index = results.indexOf(minResult);
      this.currentRecipe = this.allPossibleRoutes.get(index);
      minResult.add(0, this);
      return minResult;
    } 
    return null;
  }
  
  @Nullable
  public List<com.cirmuller.maidaddition.Utils.CraftingTasks.CraftingTask> createCraftingTasksList(CraftingRecipe recipe) {
    List<AbstractCraftingTask> tmp = createAbstractCraftingTasksList(recipe);
    if (tmp == null)
      return null; 
    List<com.cirmuller.maidaddition.Utils.CraftingTasks.CraftingTask> result = new ArrayList<>(tmp.size());
    for (AbstractCraftingTask task : tmp)
      result.add(new com.cirmuller.maidaddition.Utils.CraftingTasks.CraftingTask(task)); 
    return result;
  }
}
